import { canUseDOM } from "react-native-web-internals";
function getQuery() {
  return canUseDOM && window.matchMedia != null ? window.matchMedia("(prefers-color-scheme: dark)") : null;
}
const query = getQuery(),
  listenerMapping = /* @__PURE__ */new WeakMap(),
  Appearance = {
    getColorScheme() {
      return query && query.matches ? "dark" : "light";
    },
    addChangeListener(listener) {
      let mappedListener = listenerMapping.get(listener);
      mappedListener || (mappedListener = ({
        matches
      }) => {
        listener({
          colorScheme: matches ? "dark" : "light"
        });
      }, listenerMapping.set(listener, mappedListener)), query && query.addListener(mappedListener);
      function remove() {
        const mappedListener2 = listenerMapping.get(listener);
        query && mappedListener2 && query.removeListener(mappedListener2), listenerMapping.delete(listener);
      }
      return {
        remove
      };
    }
  };
var Appearance_default = Appearance;
export { Appearance_default as default };
//# sourceMappingURL=index.mjs.map
